> For the complete documentation index, see [llms.txt](https://docs.arkannis.net/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.arkannis.net/programming/courses/python-pcap-31-03-course/functions-and-variable-scope/scope-and-nested-functions.md).

# Scope and Nested functions

## Scope and Nested functions:

```python
age = 27 # This is known as global scope
print(age)

def increase_age():
	age = 30 # This is known as local scope
	def add_4_to_age_incorrect():
		age = age + 4 # This does not know about the age above
	
	# You can pass the variable to the nested function like so:
	def add_4_to_age_correct(age):
		age = age + 4 # This WILL know about the age defined above
		
	# Calling the nested function:
	add_4_to_age_correct(age) # The defined age - 30 will be passed to the nested function
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.arkannis.net/programming/courses/python-pcap-31-03-course/functions-and-variable-scope/scope-and-nested-functions.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
